/*
 *
 * Copyright 2002 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * Redistribution and use in source and binary forms, with or
 * without modification, are permitted provided that the following
 * conditions are met:
 * 
 * - Redistributions of source code must retain the above copyright
 *   notice, this list of conditions and the following disclaimer.
 * 
 * - Redistribution in binary form must reproduce the above
 *   copyright notice, this list of conditions and the following
 *   disclaimer in the documentation and/or other materials
 *   provided with the distribution.
 * 
 * Neither the name of Sun Microsystems, Inc. or the names of
 * contributors may be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * 
 * This software is provided "AS IS," without a warranty of any
 * kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
 * EXCLUDED. SUN AND ITS LICENSORS SHALL NOT BE LIABLE FOR ANY
 * DAMAGES OR LIABILITIES SUFFERED BY LICENSEE AS A RESULT OF OR
 * RELATING TO USE, MODIFICATION OR DISTRIBUTION OF THIS SOFTWARE OR
 * ITS DERIVATIVES. IN NO EVENT WILL SUN OR ITS LICENSORS BE LIABLE
 * FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT,
 * SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
 * CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF
 * THE USE OF OR INABILITY TO USE THIS SOFTWARE, EVEN IF SUN HAS
 * BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 * 
 * You acknowledge that this software is not designed, licensed or
 * intended for use in the design, construction, operation or
 * maintenance of any nuclear facility.
 * 
 */

package bookstore.messages;

import java.util.*;

public class BookstoreMessages_en_US extends ListResourceBundle implements java.io.Serializable {

  public Object[][] getContents() {
    return contents;
  }

  static final Object[][] contents = {

  {"ServerError", "Your request cannot be completed.  The server got the following error: "},
  {"TitleServerError", "Server Error"},
  {"TitleShoppingCart", "Shopping Cart"},
  {"TitleReceipt", "Receipt"},
  {"TitleBookCatalog", "Book Catalog"},
  {"TitleCashier", "Cashier"},
  {"TitleBookDescription", "Book Description"},
  {"What", "What We\'re Reading"},
  {"Talk", " talks about how web components can transform the way you develop applications for the web. This is a must read for any self respecting web developer!"},
  {"Start", "Start Shopping"},
  {"Critics", "Here's what the critics say: "},
  {"Price", "Our Price: "},
  {"CartRemoved", "You just removed "},
  {"CartCleared", "You just cleared your shopping cart!"},
  {"CartContents", "Your shopping cart contains "},
  {"CartItem", " item"},
  {"CartItems", " items"},
  {"CartAdded1", "You added "},
  {"CartAdded2", " to your shopping cart."},
  {"CartCheck", "Check Shopping Cart"},
  {"CartAdd", "Add to Cart"},
  {"By", "by"},
  {"Buy", "Buy Your Books"},
  {"Choose", "Please choose from our selections:"},
  {"ItemQuantity", "Quantity"},
  {"ItemTitle", "Title"},
  {"ItemPrice", "Price"},
  {"RemoveItem", "Remove Item"},
  {"Subtotal", "Subtotal:"},
  {"ContinueShopping", "Continue Shopping"},
  {"Checkout", "Check Out"},
  {"ClearCart", "Clear Cart"},
  {"CartEmpty", "Your cart is empty."},
  {"Amount", "Your total purchase amount is:"},
  {"Purchase", "To purchase the items in your shopping cart, please provide us with the following information:"},
  {"Name", "Name:"},
  {"CCNumber", "Credit Card Number:"},
  {"Submit", "Submit Information"},
  {"Catalog", "Back to the Catalog"},
  {"ThankYou", "Thank you for purchasing your books from us, "},
  {"OrderError", "Your order could not be completed."}
  };
}

